var prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var fgPrefsBranch = prefObj.getBranch("foxgame.userprefs.");

var fgboolPrefsTrue = new Array("foxgameRemovePlanets","foxgameFlotaTime",
				"foxgameHighlightPrivates","foxgameReplicateDeleteOptions","foxgameSelectUniverse",
				//"foxgamePlanetsTooltips","foxgameKeyNavigation",
				"foxgameResearchTime","foxgameHighlightAllyMessages","foxgameHighlightBigDebris",
				"foxgameBuildingsTime","foxgameBuildingTime", "foxgameFlotaReturnTime");
var fgboolPrefsFalse = new Array("foxgameAddMilosButtons", "foxgameAddOverviewTime", "foxgameRemoveOverviewTime");

var fgcharPrefs = new Array("fgDebrisMin");

var fgcolorPrefs = new Array("fgPrivateColor", "fgAllyColor", "fgDebrisColor");

var fgcharPrefsSelects = new Array("fgServer","fgUni");

try {
    var	fgUniversesXml = document.implementation.createDocument("", "", null);
    fgUniversesXml.async = false;
    fgUniversesXml.load("chrome://foxgame/content/fgUniverses.xml", "text/xml");
} catch (e) {
	alert(e);
}

function fillMenuList(id, prefix, values){
    
    var menupopup = document.getElementById(id);
    
    var sortedKeys = foxtrick_getSortedKeysForArray(values, "name");
    
    for (var i in sortedKeys) {
        
        var key = sortedKeys[i];
        
        var label = values[key]["name"];
        if (typeof(values[key]["version"]) != 'undefined') {
            label = label + " " + values[key]["version"];
        }
        
        label = label + " (by " + values[key]["author"]["name"] + ")";
        
        // for starsets:
        if (typeof(values[key]["number-of-stars"]) != 'undefined') {
            
            var temp = values[key]["number-of-stars"];
            if (typeof(values[key]["zero"]) != 'undefined') {
               temp++;
            }
            
            label += ", " + temp + " " + messageBundle.GetStringFromName("foxtrick.prefs.stars") ;
            
            if (typeof(values[key]["merge-recommended"]) != 'undefined') {
                label += ", " + messageBundle.GetStringFromName("foxtrick.prefs.mergemoderec") ;
            }

        }
        

        var obj = document.createElement("menuitem");
        obj.setAttribute("id", prefix+key);
        obj.setAttribute("label", label);
        obj.setAttribute("value", key);
        
        menupopup.appendChild(obj);
        
    }

}

function fillListFromXml(id, prefix, xmlDoc, elem, descAttr, valAttr){
    
    var values = xmlDoc.getElementsByTagName(elem);
    var menupopup = document.getElementById(id);
    var langs = new Array();
    	
    for (var i=0; i<values.length; i++) {
        var label = values[i].attributes.getNamedItem(descAttr).textContent;
        var value = values[i].attributes.getNamedItem(valAttr).textContent;
        langs[langs.length] = new Array(label,value);
    }

    function sortfunction(a,b) {
        return a[0].localeCompare(b[0]);
    }
    
    langs.sort(sortfunction);

    for (var i=0; i<langs.length; i++) {
        
        var label = langs[i][0];
        var value = langs[i][1];

        var obj = document.createElement("menuitem");
        obj.setAttribute("id", prefix+value);
        obj.setAttribute("label", label);
        obj.setAttribute("value", value);
        
        menupopup.appendChild(obj);
        
    }

}

function fillSubListFromXml(id, prefix, xmlDoc, elem, descAttr, valAttr, fatherElem, fatherAtrr, fatherVal){
    
    try {
	//alert('//'+fatherElem+'[@'+fatherAtrr+'="'+fatherVal+']/descendant::'+elem);
    var values = xmlDoc.evaluate('//'+fatherElem+'[@'+fatherAtrr+'="'+fatherVal+'"]/descendant::'+elem,xmlDoc,null,XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null)
    var menupopup = document.getElementById(id);

    while (menupopup.childNodes.length > 0) {
	menupopup.removeChild(menupopup.firstChild);
    }
    
    var langs = new Array();
    
	
    for (var i=0; i<values.snapshotLength; i++) {
        var label = values.snapshotItem(i).attributes.getNamedItem(descAttr).textContent;
        var value = values.snapshotItem(i).attributes.getNamedItem(valAttr).textContent;
        langs[langs.length] = new Array(label,value);
    }

    function sortfunction(a,b) {
        return a[0].localeCompare(b[0]);
    }
    
    langs.sort(sortfunction);

    for (var i=0; i<langs.length; i++) {
        
        var label = langs[i][0];
        var value = langs[i][1];

        var obj = document.createElement("menuitem");
        obj.setAttribute("id", prefix+value);
        obj.setAttribute("label", label);
        obj.setAttribute("value", value);
        
        menupopup.appendChild(obj);    
    }
	} catch(e) {
		alert(e);
	}
}

function loadUnis(){
	try {
	var server = document.getElementById("fgServer").selectedItem.value;
	fillSubListFromXml("fgUniPopup", "fgUni-", fgUniversesXml, "universe", "name", "value", "index", "url", server);
	document.getElementById("fgUni").selectedItem = null;
	} catch(e) { alert(e);}
}

function fillListBox(id, suffix, values, checkedFunction) {
	
    var listbox = document.getElementById(id);

    var sortedKeys = foxtrick_getSortedKeysForArray(values, "title");
    
    for (var i in sortedKeys) {
        
        var key = sortedKeys[i];
        
        var label = values[key]["title"];
        
        var obj = document.createElement("listitem");
        obj.setAttribute("label", label);
        obj.setAttribute("value", key);
        obj.setAttribute("type", "checkbox");
        obj.id = key+suffix;

        listbox.appendChild(obj);
        listbox.ensureElementIsVisible(obj);
        
    }
    
    listbox.scrollToIndex(0);
	
}


function initFoxGamePreferences() {
    
    try {
            
//    fillMenuList("starsStylePopup", "starsStyle-", starsets);

//    fillListBox("listbox-links", "showLink", stats, getShowLink);
    
    } catch (e) {
        foxtrickdebug(e);
    }
    
    try {
        fillListFromXml("fgServerPopup", "fgServer-", fgUniversesXml, "index", "url", "url");
//        fillListFromXml("htCurrencyPopup", "htCurrency-", htCurrenciesXml, "currency", "name", "code");
    } catch (e) {
        foxtrickdebug(e);
    }
    
    for (var i=0; i<fgboolPrefsTrue.length; i++) {
        try {
            var temp = fgboolPrefsTrue[i];
            document.getElementById(temp).checked=fgGetBooleanPref(temp,true);
        } catch (e) {
		document.getElementById(temp).checked=true;
	  }
    }
    for (var i=0; i<fgboolPrefsFalse.length; i++) {
        try {
            var temp = fgboolPrefsFalse[i];
            document.getElementById(temp).checked=fgGetBooleanPref(temp,false);
        } catch (e) {
		document.getElementById(temp).checked=false;
	  }
    }

    for (var i=0; i<fgcharPrefs.length; i++) {
        try {
            var temp = fgcharPrefs[i];
            document.getElementById(temp).value=fgPrefsBranch.getCharPref(temp);
        } catch (e) {}
    }

    for (var i=0; i<fgcolorPrefs.length; i++) {
        try {
            var temp = fgcolorPrefs[i];
            document.getElementById(temp).value=fgPrefsBranch.getCharPref(temp);
        } catch (e) {
		document.getElementById(temp).value="#CC0000";
	  }
    }
    
    for (var i=0; i<fgcharPrefsSelects.length; i++) {
        try {
            var temp = fgcharPrefsSelects[i];
            document.getElementById(temp).selectedItem=document.getElementById(temp + "-" + fgPrefsBranch.getCharPref(temp));
		if (temp == "fgServer")
		  loadUnis();
        } catch (e) {}
    }                  

}


function savePreferences() {
    
    try {

        for (var i=0; i<fgboolPrefsFalse.length; i++) {
            var temp = fgboolPrefsFalse[i];
            fgPrefsBranch.setBoolPref(temp, document.getElementById(temp).checked);
        }
        for (var i=0; i<fgboolPrefsTrue.length; i++) {
            var temp = fgboolPrefsTrue[i];
            fgPrefsBranch.setBoolPref(temp, document.getElementById(temp).checked);
        }
        for (var i=0; i<fgcharPrefs.length; i++) {
            var temp = fgcharPrefs[i];
            fgPrefsBranch.setCharPref(temp, document.getElementById(temp).value);
        }
        for (var i=0; i<fgcolorPrefs.length; i++) {
            var temp = fgcolorPrefs[i];
            fgPrefsBranch.setCharPref(temp, document.getElementById(temp).value);
        }

        for (var i=0; i<fgcharPrefsSelects.length; i++) {
            var temp = fgcharPrefsSelects[i];
            if (document.getElementById(temp).selectedItem != null) {
                fgPrefsBranch.setCharPref(temp, document.getElementById(temp).selectedItem.value);
            }
        }
        
        return true;
        
    } catch (e) {
        alert (e);
        return true;
    }

    
}


//---------------------------------------------------------------
function initWindow() {

	initFoxGamePreferences();	    
}

function foxgame_getSortedKeysForArray(values, sortProperty) {
 
    var keys = new Array();
    
    for (var key in values) {
        keys[keys.length] = key;
    }
    
    function sortfunction(a,b) {
        return values[a][sortProperty].localeCompare(values[b][sortProperty]);
    }
    
    keys.sort(sortfunction);
    
    return keys;
    
}
//---------------------------------------------------------------
function fg_initColor() {

	var pref = window.arguments[0];

	try {
      	document.getElementById("fgColorPicker").color=fgPrefsBranch.getCharPref(pref);

   	} catch (e) {
		document.getElementById("fgColorPicker").color="#CC0000";
   	}
}

function fg_saveColor() {

	var pref = window.arguments[0];
      fgPrefsBranch.setCharPref(pref, document.getElementById("fgColorPicker").color);

	return true;
}
function fg_returnColor() {
	var ele = window.arguments[1];
	try {
		window.opener.document.getElementById(ele).value = document.getElementById("fgColorPicker").color;
	} catch(e) {
		alert(e);
	}
}

function fg_openColor(pref,ele) {
	window.openDialog('chrome://foxgame/content/foxGameColorPicker.xul','ColorPicker','chrome',pref,ele);
	return true;
}